]> arthur.barton.de Git - ngircd-alex.git/blobdiff - src/testsuite/stress-server.sh
Fixes to who-test: accept any ident, escape some '*' flags.
[ngircd-alex.git] / src / testsuite / stress-server.sh
index 43305d0d7a47000327a51be9a239a9478ec72c64..0f85958e98c3acce91ebe67899fe319aea33f02b 100755 (executable)
@@ -9,7 +9,7 @@
 # (at your option) any later version.
 # Please read the file COPYING, README and AUTHORS for more information.
 #
-# $Id: stress-server.sh,v 1.12 2004/09/04 16:14:47 alex Exp $
+# $Id: stress-server.sh,v 1.16 2005/12/30 22:13:21 alex Exp $
 #
 
 # detect source directory
@@ -17,7 +17,7 @@
 
 # parse command line
 [ "$1" -gt 0 ] 2> /dev/null && CLIENTS="$1" || CLIENTS=5
-[ "$2" -gt 0 ] 2> /dev/null && MAX="$2" || MAX=5
+[ "$2" -gt 0 ] 2> /dev/null && MAX="$2" || MAX=-1
 
 # get our name
 name=`basename $0`
@@ -38,6 +38,9 @@ fi
 # hello world! :-)
 echo "      stressing server with $CLIENTS clients (be patient!):"
 
+# read in functions
+. ${srcdir}/functions.inc
+
 # create scripts for expect(1)
 no=0
 while [ ${no} -lt $CLIENTS ]; do
@@ -47,23 +50,27 @@ while [ ${no} -lt $CLIENTS ]; do
   no=`expr ${no} + 1`
 done
 
-PS_FLAGS="-f"
-ps $PS_FLAGS >/dev/null 2>&1
-[ $? -ne 0 ] && PS_FLAGS="a"
+# run first script and check if it succeeds
+echo_n "      checking stress script ..."
+expect tests/0.e > logs/stress-0.log 2> /dev/null
+if [ $? -ne 0 ]; then
+  echo " failure!"
+  exit 1
+else
+  echo " ok."
+fi
 
 no=0
 while [ ${no} -lt $CLIENTS ]; do
   expect tests/${no}.e > logs/stress-${no}.log 2> /dev/null &
-  no=`expr ${no} + 1`
 
-  count=`ps $PS_FLAGS | grep "expect " | wc -l`
-  count=`expr $count - 1`
-  echo "      started client $no/$CLIENTS ($count test scripts running)."
+  no=`expr ${no} + 1`
+  echo "      started client $no/$CLIENTS."
 
-  $srcdir/wait-tests.sh $MAX
+  [ $MAX -gt 0 ] && $srcdir/wait-tests.sh $MAX
 done
 
-echo -n "      waiting for clients to complete: ."
+echo_n "      waiting for clients to complete: ."
 touch logs/check-idle.log
 while true; do
   expect ${srcdir}/check-idle.e >> logs/check-idle.log; res=$?
@@ -72,10 +79,10 @@ while true; do
 
   # there are still clients connected. Wait ...
   sleep 3
-  echo -n "."
+  echo_n "."
 done
 
-[ $res -eq 0 ] && echo " done." || echo " ERROR!"
+[ $res -eq 0 ] && echo " ok." || echo " failure!"
 
 exit $res